
/******************************************************************************
   SyncWall: Wallpaper manager
   Copyright(C) 2011-2013  xbee@xbee.net

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *******************************************************************************/

#include "ThreadPool.h"

bool ThreadPool::instanceFlag = false;
ThreadPool* ThreadPool::single = NULL;

ThreadPool* ThreadPool::getInstance()
{
    if(!instanceFlag)
    {
        single = new ThreadPool();
        instanceFlag = true;
        return single;
    }
    else
    {
        return single;
    }
}

ThreadPool::ThreadPool()
{
// create the treads
    for (int i = 0; i <  QThread::idealThreadCount(); i++)
    {
        m_threadPool << new QThread;

        m_threadPool.at(i)->start();
    }
}

void ThreadPool::stop()
{
    // stop each running thread properly
    foreach(QThread * th, m_threadPool)
    {
        if ( th->isRunning() )
        {
            th->quit();
            th->wait(2000);
        }
    }

    foreach(QThread * th, m_reservedThreadPool)
    {
        if ( th->isRunning() )
        {
            th->quit();
            th->wait(2000);
        }
    }
}

QThread *ThreadPool::getThread()
{
    return m_threadPool[qrand() % m_threadPool.size()];
}

QThread *ThreadPool::getReservedThread()
{
    QThread *th = new QThread();
    m_reservedThreadPool << th;
    th->start();
    return th;
}
