#ifndef _MAINWINDOWSERVER_H_
#define _MAINWINDOWSERVER_H_

#include <QtCore/QDebug>

#include <QtGui/QMainWindow>

#include "NetworkMessage.h"

namespace Ui
{
class MainWindowServer;
}

class TcpServer;

class MainWindowServer : public QMainWindow
{
    Q_OBJECT

public:

    explicit MainWindowServer(QWidget *parent = 0);
    ~MainWindowServer();

public slots:

    void on_pushButtonWaitForClient_toggled(bool);
    void on_pushButtonSendMessage_pressed();
    void connectionChanged(quint8 new_state);
    void newReceivedMessage(const NetworkMessage &, const QString &client);
    void on_pushButtonQuit_pressed();

    void on_spinBoxUdpPort_valueChanged(int);

    void on_pushButtonAutoStart_toggled(bool);

    void newMessage(const QString &);

    void on_pushButtonImage_pressed();
    void on_pushButtonSendImage_pressed();

private:

    void saveSettings();
    void loadSettings();

    void prepareConnection();
    void setConnection(bool);
    void previewImage(const QString &);

    void send(const NetworkMessage &);

    Ui::MainWindowServer *m_ui;

    TcpServer *m_server;
    unsigned int m_counter;

	int m_tcpPort;
	int m_timeout;
    bool m_autoStart;
    QString m_lastImage;
    QString m_lastString;
};

#endif // _MAINWINDOWSERVER_H_
